/** Rill v0.0.454 https://www.npmjs.com/package/rill License: MIT*/
var callbacks, event, handleClick, handlePop, hijack, ref, urllite;

event = require("component-event");

urllite = require("urllite");

callbacks = [];

hijack = module.exports = {
  listen: function(element) {
    if (element == null) {
      element = window;
    }
    event.bind(element, "popstate", handlePop);
    event.bind(element, "submit", handleClick);
    event.bind(element, "click", handleClick);
    return hijack;
  },
  createServer: function(cb) {
    callbacks.push(cb);
    return hijack;
  },
  goTo: function(url, arg) {
    var cb, headers, i, len, method, ref, replaceState, title;
    ref = arg != null ? arg : {}, method = ref.method, headers = ref.headers, title = ref.title, replaceState = ref.replaceState;
    if (method == null) {
      method = "GET";
    }
    if (headers == null) {
      headers = {};
    }
    if (title == null) {
      title = "";
    }
    if (typeof url === "string") {
      url = urllite(url);
    }
    url.method = method;
    url.headers = headers;
    url.subdomains = (url.host || '').split('.').reverse().slice(2);
    window.history[Boolean(replaceState) ? "replaceState" : "pushState"](url, title, url.href);
    for (i = 0, len = callbacks.length; i < len; i++) {
      cb = callbacks[i];
      cb(url);
    }
  }
};

ref = require("./handlers"), handleClick = ref.handleClick, handlePop = ref.handlePop;
