/** Rill v0.0.454 https://www.npmjs.com/package/rill License: MIT*/
var Buffer, isType, toStr, typeClass;

toStr = Object.prototype.toString;

Buffer = Buffer || null;

typeClass = {
  string: "[object String]",
  number: "[object Number]",
  boolean: "[object Boolean]",
  date: "[object Date]",
  regexp: "[object RegExp]",
  error: "[object Error]",
  "function": "[object Function]",
  "arguments": "[object Arguments]",
  object: "[object Object]",
  array: "[object Array]"
};

isType = function(type) {
  return function(val) {
    return (typeof val === type && typeof val !== "object") || (typeof val === "object" || typeof val === "function") && toStr.call(val) === typeClass[type];
  };
};

module.exports = {
  String: isType("string"),
  Number: isType("number"),
  Boolean: isType("boolean"),
  Date: isType("date"),
  RegExp: isType("regexp"),
  Error: isType("error"),
  Function: isType("function"),
  Arguments: isType("arguments"),
  Object: isType("object"),
  Array: isType("array"),
  Stream: function(val) {
    return val && "funciton" === typeof val.pipe;
  },
  Buffer: function(val) {
    return (Buffer != null) && val && val instanceof Buffer;
  }
};
